<?php

/*
Plugin Loader version 2.0 beta 11 for CMSimple v2.6, v2.7 . . . 3.0, 3.2 .....

Modified by Till after discussion in the German CMSimple forum with Holger und Gert (October 2008)

Edited by  Jan Neugebauer (December, 1st 2006) / Redigeret af  Jan Neugebauer (1. December 2006)
http://www.internet-setup.de/cmsimple/

Based on original script by  Michael Svarrer / Basret p originalt script af  Michael Svarrer
http://cmsimpleplugins.svarrer.dk

Updated 22. September 2006 by Peter Andreas Harteg and released under the CMSimple license in the CMSimple distrubution with permission by copyright holders.
	Opdatret 22. September 2006 af Peter Andreas Harteg og udgivet under CMSimple licensen i CMSimple distrubution med tiladelse fra copyright indehaverne.

For licence see notice in /cmsimple/cms.php and http://www.cmsimple.dk/?Licence
	Se licens beskrivelserne i /cmsimple/cms.php og http://www.cmsimple.dk/?Licence


For changelog please refer to original distribution file available at
	For changelog se venligst i den originale distributions fil p
http://www.internet-setup.de/cmsimple/

Usage/Brug:

This plugin loader will load compatible plugins avaliable under the plugins folder into CMSimple:
	Denne plugin loader vil loade kompartible plugins ind i plugins folderen i CMSimple:

Step 0 - In /cmsimple/config.php set $cf['plugins']['folder']="plugins"; (or set plugins_folder to plugins under CMSimple configuration settings)
	Trin 0 - I /cmsimple/config.php indstil $cf['plugins']['folder']="plugins"; (eller indstil plugins_folderen til plugins under CMSimple konfigurations indstillinger)
Step 1 - Installation is done and you should be ready to install plugins
	Trin 1 - Installationen er frdig og du skulle vre klar til at installre plugins
         Plugins avaliable at / Plugins kan vlges her:
         http://www.internet-setup.de/cmsimple/
         http://cmsimpleplugins.svarrer.dk
         http://famnissen.dk/cmsimple_addon/
         http://www.jat-at-home.be
         http://www.cmsimple.dk/?Addons_and_plugins
*/


global $cf, $hjs, $sl, $sn;

// Deny direct access of Plugin Loader file
// forbyd direkte adgang af plugin loader filer
if (!isset($sn) OR count(debug_backtrace()) <= 1) { die('access denied'); }

global $pluginloader_cfg;
$pluginloader_cfg=ARRAY();
$pluginloader_tx=ARRAY();

if (!isset($hjs)) { $hjs=''; }

$pluginloader_cfg['folder_down'] = '';
// Set language for the Plugin Loader
// Indstil sprog for Plugin Loaderen
if (preg_match('/\/[A-z]{2}\/[^\/]*/', sv('PHP_SELF'))) {
	$pluginloader_cfg['language'] = strtolower(preg_replace('/.*\/([A-z]{2})\/[^\/]*/','\1',sv('PHP_SELF')));
	$pluginloader_cfg['folder_down'] = '.';
} else {
	$pluginloader_cfg['language'] = strtolower($cf['language']['default']);
}


if (!isset($cf['plugins']['folder']) OR empty($cf['plugins']['folder']) OR !is_dir($cf['plugins']['folder'])) {
	$cf['plugins']['folder'] = 'plugins';
}


$pluginloader_cfg['foldername_pluginloader'] = 'pluginloader';
$pluginloader_cfg['folder_pluginloader'] = $pluginloader_cfg['folder_down'].'./'.$cf['plugins']['folder'].'/'.$pluginloader_cfg['foldername_pluginloader'].'/';
$pluginloader_cfg['folder_css'] = $pluginloader_cfg['folder_pluginloader'].'css/';
$pluginloader_cfg['folder_languages'] = $pluginloader_cfg['folder_pluginloader'].'languages/';
$pluginloader_cfg['file_css'] = $pluginloader_cfg['folder_css'].'stylesheet.css';
$pluginloader_cfg['form_namespace'] = 'PL3bbeec384_';


// include Plugin Loader stylesheet and add it to CMSimple
$hjs .= tag('link rel="stylesheet" type="text/css" href="'.$pluginloader_cfg['file_css'].'"');


// Use english language, if $sl or default language are not supported by the Plugin Loader
// Brug det engelske sprog, hvis $sl eller standard sproget ikke understttes af Plugin Loaderen
if (empty($pluginloader_cfg['language'])) { $pluginloader_cfg['language'] = 'en'; }

// include Plugin Loader language file
$pluginloader_cfg['file_language'] = $pluginloader_cfg['folder_languages'].$pluginloader_cfg['language'].'.php';
if (!@include_once($pluginloader_cfg['file_language'])) { echo 'Language file for Plugin Loader not found!<br>File: '.$pluginloader_cfg['file_language'].'<br>Current Path: '.$_SERVER['PHP_SELF'].'<hr>'; }


/*
 * If admin is logged in create a select box with all available plugins.
*/
if ($adm) {
	
	$i = 0;
	
	$pluginloader_plugin_selectbox = '';
	
	$pluginloader_plugin_selectbox .= $pluginloader_tx['menu']['available_plugins'];
	$pluginloader_plugin_selectbox .= '<form style="display: inline; margin-bottom: 0px;">';
	$pluginloader_plugin_selectbox .= '<select name="Plugins" onchange="location.href=this.options[this.selectedIndex].value" >';
	$pluginloader_plugin_selectbox .= '<option value="?&normal">'.$pluginloader_tx['menu']['select_plugin'].'</option>';
	$handle = opendir($pth['folder']['plugins']);
	$found_plugins = false;
	
	while ($plugin = readdir($handle)) {
		if ($plugin != '.' && $plugin != '..' && is_dir($pth['folder']['plugins'].$plugin)) {

			PluginFiles($plugin);
			if (file_exists($pth['file']['plugin_admin'])) {
				$pluginloader_plugin_selectbox .= '<option value="'.$sn.'?&amp;'.$plugin.'&amp;normal"';
				reset($_GET);
				list ($firstgetkey) = each($_GET);
				if ($firstgetkey == $plugin)
					$pluginloader_plugin_selectbox .= ' selected="selected"';
				$pluginloader_plugin_selectbox .= '>'.ucwords($plugin).'</option>';
				$admin_plugins[$i] = $plugin;
				$found_plugins = true;
				$i++;
			} // if (file_exists($pth['file']['plugin_admin']))
		}
	}
	
	$pluginloader_plugin_selectbox .= '</select></form>';

	PluginMenu('ROW', '', '', '', $plugin_menu_style);
	PluginMenu('DATA', '', '', $pluginloader_plugin_selectbox, $plugin_menu_style);
	$o .=	PluginMenu('SHOW');
} // if ($adm)


/*
 * Include plugin (and plugin files)
 * Include plugin (og plugin filer)
*/
$handle = opendir($pth['folder']['plugins']);

while ($plugin = readdir($handle)) {
	
	if ($plugin != "." AND $plugin != ".." AND $plugin != $pluginloader_cfg['foldername_pluginloader'] AND is_dir($pth['folder']['plugins'].$plugin)) {
		
		PluginFiles($plugin);

		// Load plugin or die
		if (!@ include ($pth['file']['plugin_index'])) {
			die($pluginloader_tx['error']['plugin_error'].$pluginloader_tx['error']['cntopen'].$pth['file']['plugin_index']);
		}

		// If current language file is missing try to copy english language to current language file
		// Hvis den nuvrende sprogfil mangler, forsg at kopiere engelisk sprog til nuvrende sprog fil
		if (!file_exists($pth['file']['plugin_language'])) {
			if (file_exists($pth['folder']['plugins'].$plugin.'/languages/en.php')) {
				$is_copied = @ copy($pth['folder']['plugins'].$plugin.'/languages/en.php', $pth['file']['plugin_language']);
				if ($is_copied == FALSE) {
					// Set language file to "EN" if copying failed
					// Indstil sprogfilen til "EN" hvis kopieringen mislykkes
					$pth['file']['plugin_language'] = $pth['folder']['plugins'].$plugin.'/languages/en.php';
				}
			}
		}

		// Load plugin language or die
		if (!@ include ($pth['file']['plugin_language'])) {
			//die($pluginloader_tx['error']['plugin_error'].$pluginloader_tx['error']['cntopen'].$pth['file']['plugin_language']);
		}

		// Load plugin config
		if (!@ include ($pth['file']['plugin_config'])) {
			// do nothing
			// gr ingenting
		}
		// Add plugin css to the header of CMSimple/Template
		// Tilfj plugin css i headeren i CMSimple/Template
		if (file_exists($pth['file']['plugin_stylesheet'])) {
			$hjs .= tag('link rel="stylesheet" href="'.$pth['file']['plugin_stylesheet'].'" type="text/css"');
		}
	
	} // if ($plugin)

} // while ($plugin = readdir($handle))


/*
 * Load admin functions (admin.php, if exists) of plugin
*/
if ($adm) {
	// Load common plugin admin functions or die
	//if(!@include($pth['folder']['plugins'].'/admin_common.php')) {
	//	die($pluginloader_tx['error']['plugin_error'].$pluginloader_tx['error']['cntopen'].$pth['folder']['plugins'].'/admin_common.php');
	//}
	if ($found_plugins == true) {
		foreach ($admin_plugins as $plugin) {
			PluginFiles($plugin);
			if (file_exists($pth['file']['plugin_admin'])) {
				@include ($pth['file']['plugin_admin']);
			}
		}
	}
} // if ($adm)

// Plugin functions
unset($plugin);
/*
 * Set plugin filenames.
 * Indstil plugin filenavne.
*/
function PluginFiles($plugin) {
	
	global $cf, $pth, $sl;
	global $pluginloader_cfg;

	$pth['folder']['plugin'] = $pth['folder']['plugins'].$plugin.'/';
	$pth['folder']['plugin_config'] = $pth['folder']['plugins'].$plugin.'/config/';
	$pth['folder']['plugin_content'] = $pth['folder']['plugins'].$plugin.'/content/';
	$pth['folder']['plugin_css'] = $pth['folder']['plugins'].$plugin.'/css/';
	$pth['folder']['plugin_help'] = $pth['folder']['plugins'].$plugin.'/help/';
	$pth['folder']['plugin_includes'] = $pth['folder']['plugins'].$plugin.'/includes/';
	$pth['folder']['plugin_languages'] = $pth['folder']['plugins'].$plugin.'/languages/';

	$pth['file']['plugin_index'] = $pth['folder']['plugin'].'index.php';
	$pth['file']['plugin_admin'] = $pth['folder']['plugin'].'admin.php';

	if (file_exists($pth['folder']['plugin_languages'].strtolower($sl).'.php')) {
		$pth['file']['plugin_language'] = $pth['folder']['plugin_languages'].strtolower($sl).'.php';
	}
	else {
		$pth['file']['plugin_language'] = $pth['folder']['plugin_languages'].strtolower($cf['language']['default']).'.php';
	}
	
	$pth['file']['plugin_config'] = $pth['folder']['plugin_config'].'config.php';
	$pth['file']['plugin_stylesheet'] = $pth['folder']['plugin_css'].'stylesheet.css';

	$pth['file']['plugin_help'] = $pth['folder']['plugin_help'].'help_'.strtolower($pluginloader_cfg['language']).'.htm';
	if (!file_exists($pth['file']['plugin_help'])) {
		$pth['file']['plugin_help'] = $pth['folder']['plugin_help'].'help_en.htm';
	}
	if (!file_exists($pth['file']['plugin_help']) AND file_exists($pth['folder']['plugin_help'].'help.htm')) {
		$pth['file']['plugin_help'] = $pth['folder']['plugin_help'].'help.htm';
	}
} // function PluginFiles()


/*
 * Create menu of plugin (add row, add tab)
*/
function PluginMenu($add='', $link='', $target='', $text='', $style=ARRAY()) {

	$add = strtoupper($add);
	
	if (!isset($GLOBALS['pluginloader']['plugin_menu'])) { $GLOBALS['pluginloader']['plugin_menu']=''; }
	if (!isset($style['row'])) { $style['row']='class="edit" style="width: 100%;"'; }
	if (!isset($style['tab'])) { $style['tab']=''; }
	if (!isset($style['link'])) { $style['link']=''; }

	$menu_row = '<table {{STYLE_ROW}} cellpadding="1" cellspacing="0" border="1"><tr>{{TAB}}</tr></table>';
	$menu_tab = '<td {{STYLE_TAB}}><a {{STYLE_LINK}} href="{{LINK}}" {{TARGET}}>{{TEXT}}</a></td>';
	$menu_tab_data = '<td {{STYLE_DATA}}>{{TEXT}}</td>';
	
	// Add new row for menu of plugin (or Plugin Loader)
	if ($add == 'ROW') {
		$new_menu_row = $menu_row;
		$new_menu_row = str_replace('{{STYLE_ROW}}', $style['row'], $new_menu_row);
		$GLOBALS['pluginloader']['plugin_menu'] .= $new_menu_row;
	}

	// Add a new tab to the menu row
	if ($add == 'TAB') {
		$new_menu_tab = $menu_tab;
		$new_menu_tab = str_replace('{{STYLE_TAB}}', $style['tab'], $new_menu_tab);
		$new_menu_tab = str_replace('{{STYLE_LINK}}', $style['link'], $new_menu_tab);
		$new_menu_tab = str_replace('{{LINK}}', $link, $new_menu_tab);
		$new_menu_tab = str_replace('{{TARGET}}', $target, $new_menu_tab);
		$new_menu_tab = str_replace('{{TEXT}}', $text, $new_menu_tab);
		
		// Add tab to row
		$GLOBALS['pluginloader']['plugin_menu'] = str_replace('{{TAB}}', $new_menu_tab.'{{TAB}}', $GLOBALS['pluginloader']['plugin_menu']);
	}

	// Add a new tab to the menu row
	// Here: user defineable data
	// Her: bruger definrbare data
	if ($add == 'DATA') {
		$new_menu_tab_data = $menu_tab_data;
		$new_menu_tab_data = str_replace('{{STYLE_DATA}}', $style['data'], $new_menu_tab_data);
		$new_menu_tab_data = str_replace('{{TEXT}}', $text, $new_menu_tab_data);
		
		// Add tab to row
		$GLOBALS['pluginloader']['plugin_menu'] = str_replace('{{TAB}}', $new_menu_tab_data.'{{TAB}}', $GLOBALS['pluginloader']['plugin_menu']);
	}

	// Show complete menu
	// Vis komplet menu
	if ($add == 'SHOW') {
		$GLOBALS['pluginloader']['plugin_menu'] = str_replace('{{TAB}}', '', $GLOBALS['pluginloader']['plugin_menu']);
		$menu = $GLOBALS['pluginloader']['plugin_menu'];
		$GLOBALS['pluginloader']['plugin_menu']='';
		return $menu;
	}

} // function PluginMenu()


/*
 * Read content from a given file.
*/
function PluginReadFile($file='') {
	
	global $pluginloader_tx;

	$is_read = ARRAY ();
	$is_read['success'] = FALSE;
	$is_read['msg'] = '';
	$is_read['content'] = '';

	if (!file_exists($file)) {
		$is_read['msg'] = $pluginloader_tx['error']['cntopen'].$file;
	} else {

		if (!is_readable($file)) {
			$is_read['msg'] = $pluginloader_tx['error']['notreadable'].$file;
		} else {
			if ($fh = @ fopen($file, "r+b")) {
				$is_read['content'] = fread($fh, filesize($file));
				@fclose($fh);
				$is_read['content'] = str_replace("\r\n", "\n", $is_read['content']);
				$is_read['content'] = str_replace("\r", "\n", $is_read['content']);
				$is_read['msg'] = $pluginloader_tx['success']['saved'].$file;
				$is_read['success'] = TRUE;
			}
		}
	}

	return $is_read;

} // function PluginReadFile()


/*
 * Write content to a given file.
 * Skriv indhold tilen given fil.
*/
function PluginWriteFile($file='', $content='', $exists=FALSE, $append=FALSE) {
	
	global $pluginloader_tx;
	
	if ($append == TRUE) { $write_mode = 'a+b'; }
	else { $write_mode = 'w+b'; }

	$is_written = ARRAY ();
	$is_written['success'] = FALSE;
	$is_written['msg'] = '';
	
	$do_write = TRUE;

	if (!file_exists($file) AND $exists == TRUE) {
		$do_write = FALSE;
		$is_written['msg'] = $pluginloader_tx['error']['cntopen'].$file;
	}

	if (file_exists($file) AND !is_writeable($file)) {
		$do_write = FALSE;
		$is_written['msg'] = $pluginloader_tx['error']['cntwriteto'].$file;
	}
	
	if ($do_write == TRUE) {
		if ($fh = @ fopen($file, $write_mode)) {
			@ fwrite($fh, $content);
			@ fclose($fh);
			$is_written['msg'] = $pluginloader_tx['success']['saved'].$file;
			$is_written['success'] = TRUE;
		}
	}

	return $is_written;

} // function PluginWriteFile()


/*
 * Prepare config data for writing to file.
*/
function PluginPrepareConfigData($var_name='', $data=ARRAY(), $plugin='') {
	$save_data = "<?php\n\n";
	foreach ($data as $key => $value) {
		$new_value = stripslashes($value);
		$save_data .= "\t".'$'.$var_name;
		if (!empty($plugin)) { $save_data .= '[\''.$plugin.'\']'; }
		$save_data .= '[\''.$key.'\']="'.str_replace('"', '\"', $new_value).'";'."\n";
	}
	$save_data .= "\n?>";

	return $save_data;
} // function PluginPrepareConfigData()


/*
 * Prepare text data for writing to file.
*/
function PluginPrepareTextData($data) {
	if (ini_get('register_gobals') == TRUE OR get_magic_quotes_gpc() == TRUE) {
		$data = str_replace("\\\\", "~DOUBLEQUOTE~", $data);
		$data = stripslashes($data);
		$data = str_replace("~DOUBLEQUOTE~", "\\", $data);
	}
	return $data;
} // function PluginPrepareTextData()


/*
 * Show form for config data
 *
 * if set $hint['mode_donotshowvarnames'] == TRUE
 * variable indexes are not show, but text information.
 * (e.g. for index 'my_name' -> $plugin_tx['example_plugin']['cf_my_name']) 
*/
function PluginSaveForm($form=ARRAY(), $style=ARRAY(), $data=ARRAY(), $hint=ARRAY()) {
	
	global $pluginloader_tx;
	$saveform='';
	$form['type'] == 'CONFIasdfasdfG';

	if (!isset($form['type']) OR ($form['type'] != 'TEXT' AND $form['type'] != 'CONFIG')) {
		$saveform .= PluginDebugger('invalid_value', debug_backtrace(), $$data, $form['type']); 
		//$saveform .= $pluginloader_tx['error']['plugin_error'].'function PluginSaveForm: \$form[\'type\']=""';
	}
	elseif ($form['type'] == 'CONFIG' AND (!is_array($data) OR count($data) == 0)) {
		$saveform .= PluginDebugger('empty', debug_backtrace(), $$data, ''); 
	}
	else {

		$form_keys= ARRAY('action', 'caption', 'errormsg', 'method', 'value_action', 'value_admin', 'value_submit');
		$style_keys= ARRAY('div', 'divcaption', 'form', 'submit', 'table', 'tdcaption', 'tdconfig', 'tdhint', 'textarea', 'input', 'inputmax');
		foreach ($form_keys AS $key) { if (!isset($form[$key])) { $form[$key]=''; } }
		foreach ($style_keys AS $key) { if (!isset($style[$key])) { $style[$key]=''; } }
	
		$saveform .= $form['errormsg'];
		$saveform .= '<div '.$style['div'].'>';

		$saveform .= '<form '.$style['form'].' action="'.$form['action'].'" method="'.$form['method'].'">';
		if (!empty($form['caption'])) { $saveform .= '<div '.$style['divcaption'].'>'.$form['caption'].'</div>'; }
	
		if ($form['type'] == 'TEXT') {
			$saveform .= '<textarea '.$style['textarea'].' name="'.$form['textarea_name'].'">'.$data.'</textarea>';
		}
	
		if ($form['type'] == 'CONFIG') {
			$saveform .= '<table '.$style['table'].' cellspacing="0" cellpadding="0" border="0">';
			$last_cap='';
			ksort($data);
			foreach ($data as $key => $value) {
				global $pluginloader_cfg;
				$var_name='';
				$val_cap = split('_', $key);
				
				if (!isset($hint['mode_donotshowvarnames']) OR $hint['mode_donotshowvarnames'] == FALSE) {
					if ($val_cap[0] != $last_cap) {
						$last_cap = $val_cap[0];
						$saveform .= '<tr><td colspan="2" '.$style['tdcaption'].'>'.$last_cap.'</td></tr>';
					}
				}
	
				// if special hints for config are defined show this info.
				if (isset($hint['cf_'.$key]) AND !empty($hint['cf_'.$key])) {
					$saveform .= '<tr><td colspan="2" '.$style['tdhint'].'>'.$hint['cf_'.$key].'</td></tr>';
				}
				
				if (isset($hint['mode_donotshowvarnames']) AND $hint['mode_donotshowvarnames'] == TRUE AND isset($hint['cf_'.$key]) AND !empty($hint['cf_'.$key])) {	$var_name = '&nbsp;';	}
				else { $var_name = str_replace("_", " ", $key).':'; }
				$saveform .= '<tr><td '.$style['tdconfig'].'>'.$var_name.'</td><td>';
				$style_textarea = $style['input'];
				$value = stripslashes($value);
				if (strlen($value) > 50) { $style_textarea = $style['inputmax']; }
				$saveform .= '<textarea '.$style_textarea.' name="'.$pluginloader_cfg['form_namespace'].$key.'" rows="1" cols="40">'.$value.'</textarea>';
				$saveform .= '</td></tr>';
			}
			$saveform .= '</table>';
		} // if ($form['type'] == 'CONFIG')
	
		$saveform .= tag('input type="hidden" name="admin" value="'.$form['value_admin'].'"');
		$saveform .= tag('input type="hidden" name="action" value="'.$form['value_action'].'"').'<br />'.tag('input type="submit" '.$style['submit'].' name="plugin_submit" value="'.$form['value_submit'].'"');
		$saveform .= '</form>';
	}	
		$saveform .= '</div>';
		
	return $saveform;
} // function PluginSaveForm()


/*
 * The part below was in file admin_common.php
 * in previous (Svarrers' versions) versions of the Plugin Loader.
*/


/*
CMSimple - Plugin Loader Plugin - version 1.0 Beta 4
 2005 - Michael Svarrer
--------------------------------------------------------------------- 
- Beta 4 : Forth beta released - 15. jun 2005
Some Notice: Undefined variable: for different variables
- Beta 3 : Third beta released - 4. jun 2005
Bugs corrected when running i REGISTER GLOBAL off enviroment
would work thanks to Jan Kanters - JAT
- Beta 2 : Second beta released - 29. may 2005 
Changed so a plugin without languages, config & settings files also 
would work thanks to Jan Kanters - JAT
- Beta 1 : First beta released - 22. may 2005 
---------------------------------------------------------------------
Disclaimer: No warranties at all, use on your own risk !
---------------------------------------------------------------------
Feedback: webmaster@svarrer.dk
---------------------------------------------------------------------
Usage: File part of Plugin Loader at http://cmsimpleplugins.svarrer.dk/ 
*/


/*
 * Create plugin menu tabs.
*/
function print_plugin_admin($main) {

	global $sn, $plugin, $pth, $sl;
	global $pluginloader_tx, $plugin_tx;

	initvar('plugin_text');
	initvar('action');
	initvar('admin');
	
	$t = '';
	$css = '';
	$config = '';
	$language = '';
	$help = '';

	$main = strtoupper($main);
	
	PluginFiles($plugin);


	if (file_exists($pth['file']['plugin_stylesheet'])) {
		$css = 'ON';
	}
	if (file_exists($pth['file']['plugin_config'])) {
		//include($pth['file']['plugin_config']);
		$config = 'ON';
	}
	if (file_exists($pth['file']['plugin_language'])) {
		//include($pth['file']['plugin_language']);
		$language = 'ON';
	}
	if (file_exists($pth['file']['plugin_help'])) {
		$help = 'ON';
	}
	
	// Use preset texts for the menu, if the plugin itself did not define text for the menu
	if (isset ($plugin_tx[$plugin]['menu_main']) AND !empty($plugin_tx[$plugin]['menu_main'])) { $pluginloader_tx['menu']['tab_main'] = $plugin_tx[$plugin]['menu_main']; }
	if (isset ($plugin_tx[$plugin]['menu_css']) AND !empty($plugin_tx[$plugin]['menu_css'])) { $pluginloader_tx['menu']['tab_css'] = $plugin_tx[$plugin]['menu_css']; }
	if (isset ($plugin_tx[$plugin]['menu_config']) AND !empty($plugin_tx[$plugin]['menu_config'])) { $pluginloader_tx['menu']['tab_config'] = $plugin_tx[$plugin]['menu_config']; }
	if (isset ($plugin_tx[$plugin]['menu_language']) AND !empty($plugin_tx[$plugin]['menu_language'])) { $pluginloader_tx['menu']['tab_language'] = $plugin_tx[$plugin]['menu_language']; }
	if (isset ($plugin_tx[$plugin]['menu_help']) AND !empty($plugin_tx[$plugin]['menu_help'])) { $pluginloader_tx['menu']['tab_help'] = $plugin_tx[$plugin]['menu_help']; }

	
	$plugin_menu_style=ARRAY();
	
	PluginMenu('ROW', '', '', '', $plugin_menu_style);
	
	if ($main == 'ON') { PluginMenu('TAB', $sn.'?&'.$plugin.'&admin=plugin_main&action=plugin_text', '', $pluginloader_tx['menu']['tab_main'], $plugin_menu_style); }
	if ($css == 'ON') {	PluginMenu('TAB', $sn.'?&'.$plugin.'&admin=plugin_stylesheet&action=plugin_text', '', $pluginloader_tx['menu']['tab_css'], $plugin_menu_style);	}
	if ($config == 'ON') { PluginMenu('TAB', $sn.'?&'.$plugin.'&admin=plugin_config&action=plugin_edit', '', $pluginloader_tx['menu']['tab_config'], ''); }
	if ($language == 'ON') { PluginMenu('TAB', $sn.'?&'.$plugin.'&admin=plugin_language&action=plugin_edit', '', $pluginloader_tx['menu']['tab_language'], ''); }
	if ($help == 'ON') { PluginMenu('TAB', $pth['file']['plugin_help'], 'target="_blank"', $pluginloader_tx['menu']['tab_help'], ''); }
	
	$t .= PluginMenu('SHOW');

	return $t;
} // function print_plugin_admin()


/*
 * Handle reading and writing of plugin files (e.g. en.php, config.php, stylesheet.css)
*/
function plugin_admin_common($action, $admin, $plugin, $hint=ARRAY()) {

	global $sn, $action, $admin, $plugin, $pth, $ts, $tx;
	global $pluginloader_tx, $plugin_tx, $plugin_cf;

	$data = '';
	$t = '';
	$error_msg='';
	
	if (!is_writeable($pth['file'][$admin])) { $error_msg = '<div class="pluginerror">'.$tx['error']['notwritable'].'<br />'.$pth['file'][$admin].'</div>'; }

	if ($admin == 'plugin_config') { $var_name='plugin_cf'; $data = $plugin_cf[$plugin]; }
	if ($admin == 'plugin_language') { $var_name='plugin_tx'; $data = $plugin_tx[$plugin]; }
	if ($admin == 'plugin_stylesheet') { $var_name = 'plugin_text'; }
	if ($admin == 'plugin_main') { $var_name = 'plugin_text'; }


	if ($action == 'plugin_text' OR $action == 'plugin_edit') {
		$hint = array_merge($hint, $plugin_tx[$plugin]);
		$form = ARRAY();
		$style = ARRAY();

		$style['form']='class="plugineditform"';
		$style['divcaption']='class="plugineditcaption"';
		$style['submit']='class="submit"';

		$form['action'] = $sn.'?&'.$plugin;
		$form['method'] = 'POST';
		$form['value_admin'] = $admin;
		$form['value_submit'] = ucfirst($tx['action']['save']);
		$form['caption'] = ucfirst(str_replace("_", " ", $plugin));
		$form['errormsg'] = $error_msg;
		
		if ($action == 'plugin_text') {
			$file_data = PluginReadFile($pth['file'][$admin]);
			$data = $file_data['content'];
			$form['type'] = 'TEXT';
			$form['value_action'] = 'plugin_textsave';
			$form['textarea_name'] = 'plugin_text';
			$style['div']='class="plugintext"';
			$style['textarea']='class="plugintextarea"';
		}			
		if ($action == 'plugin_edit') {
			$form['type'] = 'CONFIG';
			$form['value_action'] = 'plugin_save';
			$style['div']='class="pluginedit"';
			$style['table']='class="pluginedittable"';
			$style['tdcaption']='class="plugincfcap"';
			$style['tdhint']='class="plugincfhint"';
			$style['tdconfig']='class="plugincf"';
			$style['input']='class="plugininput"';
			$style['inputmax']='class="plugininputmax"';
		}
		$t .= PluginSaveForm($form, $style, $data, $hint); 
	}


	if ($action == 'plugin_save' OR $action == 'plugin_textsave') {	

		if ($action == 'plugin_save') {
			$config_data=ARRAY();
			foreach ($data as $key => $value) {
				global $pluginloader_cfg;
				$config_data[$key] = $_POST[$pluginloader_cfg['form_namespace'].$key];
			}

			$save_data = PluginPrepareConfigData($var_name, $config_data, $plugin);
		}
		
		if ($action == 'plugin_textsave') {
			$text_data = $_POST[$var_name];
			$save_data = PluginPrepareTextData($text_data);
		}

		$is_saved = PluginWriteFile($pth['file'][$admin], $save_data);
		$t .= '<br /><b>'.$is_saved['msg'].'</b><br />';
	}	

	return $t;

} // function plugin_admin_common()



function PluginDebugger($error=FALSE, $caller=FALSE, $varname=FALSE, $value=FALSE) {
	global $pluginloader_tx;
	$debug ='';
	$debug .= $pluginloader_tx['error']['plugin_error'].'';
	switch ($error) {
		case 'empty': $debug .= 'empty/no data ('.$varname.')'; break;
		default: $debug .= 'undefined error ('.$varname.')';
	}
	$debug .= '<br>in<br>';
	foreach ($caller AS $call) {
		$debug .= 'File: '.$call['file'].' - '.$call['function'].' - Line: '.$call['line'].'<br>';
	}
	return $debug;
}		  

?>